﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DecisioLinqEntity.ObjectModel {
    /// <summary>
    /// Modéle des chemins d'une version
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [System.ServiceModel.XmlSerializerFormat]
    public class CHEMIN_MODEL
    {
        /// <summary>
        /// Cout de traction entre agence départ et agence arrivé
        /// </summary>
        public Nullable<decimal> COUT_TRACTION_CALC { get; set; }
        /// <summary>
        /// non utilisé
        /// </summary>
        public Nullable<decimal> INDICE_GASOIL_TRAC_INIT { get; set; }
        /// <summary>
        ///  Code de l'agence de transit sur 6 caractèress
        /// </summary>
        public string COD_AGE_TRANSIT { get; set; }
        /// <summary>
        /// Cout de transit à la palette
        /// </summary>
        public Nullable<decimal> COUT_TRANSIT_PAL1_CALC { get; set; }
        /// <summary>
        /// non utilisé
        /// </summary>
        public Nullable<decimal> INDICE_GASOIL_TRANSIT_INIT { get; set; }
        /// <summary>
        ///  % d'utilisation initial du chemin (les coûts traction/transit sont au prorata de cette valeur)
        /// </summary>
        public decimal POURCENT_AGE_DEST_INIT { get; set; }
        /// <summary>
        ///  % d'utilisation du chemin (les coûts traction/transit sont au prorata de cette valeur)
        /// </summary>
        public decimal POURCENT_AGE_DEST_CALC { get; set; }
        /// <summary>
        /// Nombre moyen de palette par camion et par traction
        /// </summary>
        public Nullable<short> NB_TRAC_PAL_CALC { get; set; }
        /// <summary>
        ///  Cout global du chemin non structuré
        /// </summary>
        public Nullable<decimal> COUT_CHEMIN_PAL1_CALC { get; set; }
        /// <summary>
        /// Séquence oracle du chemin
        /// </summary>
        public int SEQ_CHEMIN { get; set; }
        /// <summary>
        /// LIV = livraison LH= Livraison hors zone
        /// </summary>
        public string TYP_LIV { get; set; }
        /// <summary>
        ///  Date de mise à jour
        /// </summary>
        public Nullable<System.DateTime> DAT_DMAJ { get; set; }
        /// <summary>
        /// Nombre de position ayant transité sur le chemin au cours des 3 derniers mois glissant du PTO
        /// </summary>
        public Nullable<decimal> NB_POS { get; set; }
        /// <summary>
        /// Nom de l'agence de transit
        /// </summary>
        public string LIB_AGE_TRANSIT { get; set; }
        /// <summary>
        /// Nom du dégroupeur
        /// </summary>
        public string LIB_DEGR { get; set; }
        /// <summary>
        /// Modificateur oracle
        /// </summary>
        public string C_MODIFIER { get; set; }
        /// <summary>
        /// Date de la création du chemin
        /// </summary>
        public Nullable<System.DateTime> DAT_CREA { get; set; }
        /// <summary>
        ///  Nombre de position total de la destination
        /// </summary>
        public Nullable<decimal> NB_POS_TOT { get; set; }
        /// <summary>
        /// sequence oracle de la version tarifaire
        /// </summary>
        public int SEQ_VERSION_TARIF { get; set; }
        /// <summary>
        /// sequence oracle de la destination
        /// </summary>
        public Nullable<int> SEQ_DESTINATION { get; set; }
        /// <summary>
        ///  Non utilisé : % écart du chemin par rapport à son coût initial
        /// </summary>
        public Nullable<decimal> ECART_SOL_PLAN { get; set; }
        /// <summary>
        ///  Nombre de palette par traction
        /// </summary>
        public Nullable<short> NBR_TRAC_PAL_INIT { get; set; }

        #region degroupage

        /// <summary>
        /// Code de l'agence de dégroupage du chemin ( sur 6 caractéres)
        /// </summary>
        public string COD_DEGR { get; set; }
        /// <summary>
        /// Non utilisé
        /// </summary>
        public Nullable<decimal> INDICE_GASOIL_DEGR_INIT { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour  1 palette
        /// </summary>
        public decimal COUT_DEGR_PAL1_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 2 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL2_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 3 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL3_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 4 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL4_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 5 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL5_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 6 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL6_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 7 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL7_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 8 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL8_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 9 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL9_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 10 palettes
        /// </summary>
        public decimal COUT_DEGR_PAL10_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 25 kilos
        /// </summary>
        public decimal COUT_DEGR_PO25_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 75 kilos
        /// </summary>
        public decimal COUT_DEGR_PO75_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 125 kilos
        /// </summary>
        public decimal COUT_DEGR_PO125_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 175 kilos
        /// </summary>
        public decimal COUT_DEGR_PO175_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 225 kilos
        /// </summary>
        public decimal COUT_DEGR_PO225_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 275 kilos
        /// </summary>
        public decimal COUT_DEGR_PO275_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 400 kilos
        /// </summary>
        public decimal COUT_DEGR_PO400_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 650 kilos
        /// </summary>
        public decimal COUT_DEGR_PO650_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 1150 kilos
        /// </summary>
        public decimal COUT_DEGR_PO1150_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 2250 kilos
        /// </summary>
        public decimal COUT_DEGR_PO2250_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 4000 kilos
        /// </summary>
        public decimal COUT_DEGR_PO4000_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 6000 kilos
        /// </summary>
        public decimal COUT_DEGR_PO6000_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage  initial pour 8000 kilos
        /// </summary>
        public decimal COUT_DEGR_PO8000_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 25 kilos
        /// </summary>
        public decimal COUT_DEGR_PO25_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 75 kilos
        /// </summary>
        public decimal COUT_DEGR_PO75_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 125 kilos
        /// </summary>
        public decimal COUT_DEGR_PO125_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 175 kilos
        /// </summary>
        public decimal COUT_DEGR_PO175_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 225 kilos
        /// </summary>
        public decimal COUT_DEGR_PO225_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 275 kilos
        /// </summary>
        public decimal COUT_DEGR_PO275_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 400 kilos
        /// </summary>
        public decimal COUT_DEGR_PO400_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 650 kilos
        /// </summary>
        public decimal COUT_DEGR_PO650_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 1150 kilos
        /// </summary>
        public decimal COUT_DEGR_PO1150_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 2250 kilos
        /// </summary>
        public decimal COUT_DEGR_PO2250_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 4000 kilos
        /// </summary>
        public decimal COUT_DEGR_PO4000_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 6000 kilos
        /// </summary>
        public decimal COUT_DEGR_PO6000_INFR_CALC { get; set; }
        /// <summary>
        /// Cout de dégroupage industriel initial pour 8000 kilos
        /// </summary>
        public decimal COUT_DEGR_PO8000_INFR_CALC { get; set; }

        #endregion degroupage        

        /// <summary>
        ///  Cout de traction d'un complet indicé au gasoil et a 20 min d'heure chauffeur supplémentaire
        /// </summary>
        public decimal COUT_TRACTION_LH { get; set; }
        /// <summary>
        /// Nombre de palette complet moyen par camion
        /// </summary>
        public Nullable<short> NB_PAL_LH { get; set; }
        /// <summary>
        /// heure supplémentaire des chauffeurs de traction complet
        /// </summary>
        public Nullable<decimal> NB_HR_SUPP_LH { get; set; }
        /// <summary>
        /// heures supplémentaires des chauffeurs de traction complet
        /// </summary>
        public Nullable<decimal> NB_HR_SUPP_LH_INIT { get; set; }
        /// <summary>
        /// Nombre de palette initial pour les  complets
        /// </summary>
        public Nullable<short> NB_PAL_LH_INIT { get; set; }
        /// <summary>
        ///Permet de savoir si un chemin est réel ou non (Non réel = chemin ajouté manuelement pendant la génération des destination)
        /// </summary>
        public short IS_AUTO_ADDED { get; set; }
        /// <summary>
        /// Indique si le chemin est erroné
        /// <para>0 = non</para>
        /// <para>1 = oui</para>
        /// </summary>
        public bool IS_ERROR { get; set; }
        /// <summary>
        /// Message explicite d'une erreur dans un chemin
        /// </summary>
        public string ERROR_MESSAGE { get; set; }
        /// <summary>
        /// Non utilisé
        /// </summary>
        public Nullable<short> ZONE { get; set; }
        /// <summary>
        /// Non utilisé
        /// </summary>
        public string COD_REG_CIBLE { get; set; }
        /// <summary>
        /// destination associée au chemin
        /// </summary>
        public virtual DESTINATION_MODEL DESTINATION_MODEL { get; set; }

    }
}
