﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DecisioLinqEntity.ObjectModel
{
    /// <summary>
    /// classe de model de tranche
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [System.ServiceModel.XmlSerializerFormat]
    public  class COUT_TRANCHE_MODEL
    {
        public int SEQ_VERSION_TARIF { get; set; }
        public int SEQ_DESTINATION { get; set; }

        /// <summary>
        /// coût de dégroupage de la tranche
        /// </summary>
        public Nullable<decimal> COUT_DEGR_TRANCHE { get; set; }
        /// <summary>
        /// coût de traction moyen des chemins de la tranche
        /// </summary>
        public Nullable<decimal> COUT_TRAC_MOY { get; set; }
        /// <summary>
        /// coût de transit moyen des chemins de la tranche
        /// </summary>
        public Nullable<decimal> COUT_TRANSIT_MOY { get; set; }
        /// <summary>
        /// coût de structure  de la tranche
        /// </summary>
        public Nullable<decimal> COUT_STRUCTURE { get; set; }
        /// <summary>
        /// Marge de la tranche ou écart entre le cout initial et le cout final ( pour le complet)
        /// </summary>
        public Nullable<decimal> MARGE_DEST_TRANCHE { get; set; }
        /// <summary>
        /// Marge recalculée en prenant en compte la FAFE
        /// </summary>
        public Nullable<decimal> MARGE_AVEC_FAFE{ get; set; }
        /// <summary>
        /// Sequence du modéle de tranche correspondant
        /// </summary>
        public int NUM_TRANCHE { get; set; }
        /// <summary>
        /// 1= grille palette standard <para></para> 2= grille palette avec forfait  <para></para>  3= grille poids standard <para></para> 4= grille poids avec forfait
        /// </summary>
        public short SEQ_MOD_GRILLE_VRS { get; set; }
        /// <summary>
        /// Tarif margé de la tranche
        /// </summary>
        public Nullable<decimal> TARIF_TRANCHE { get; set; }
        /// <summary>
        /// Cout de la ramasse pour la tranche selectionnée
        /// </summary>
        public Nullable<decimal> COUT_RAMASSE { get; set; }
        // <summary>
        /// Coût du Passage à quai 
        /// </summary>
        public Nullable<decimal> COUT_PAQ { get; set; }
        /// <summary>
        /// Structure fonctionnelle
        /// </summary>
        public Nullable<decimal> COUT_STRUCTURE_FONCT { get; set; }
        /// <summary>
        /// Structure opérationelle
        /// </summary>
        public Nullable<decimal> COUT_STRUCTURE_OPER { get; set; }
        /// <summary>
        /// Structure siège (CANI)
        /// </summary>
        public Nullable<decimal> COUT_STRUCTURE_SIEGE { get; set; }
        public Nullable<decimal> ECART_TRANCHE { get; set; }
        /// <summary>
        /// Liste des tarifs associés à la destination
        /// </summary>
        public short IS_VAL_VARIABLE { get; set; }
        /// <summary>
        /// Ordre d'affichage de la tranche dans la grille
        /// </summary>
        public short NORDRE_TRANCHE { get; set; }
        /// <summary>
        /// Destination associée à la tranche
        /// </summary>
        public virtual DESTINATION_MODEL DESTINATION_VERSION_MODEL { get; set; }
      
    }
}
